****************************  ******************************
*!*****************************************************************
*!
*!       Function: POISK
*!
*!*****************************************************************
FUNCTION poisk
 PARAMETERS m.r0,m.c0,M_FUNC,M.tit,M_usl,;
  field1,width1,rname1,index1,;
  field2,width2,rname2,index2,;
  field3,width3,rname3,index3,;
  field4,width4,rname4,index4,;
  field5,width5,rname5,index5


*!*	  m.r0, m.c0 -   
*!*	  M_FUNC     -    
*!*	  M.tit      -  
*!*	  M_usl      - 
*!*	  field1,width1,rname1,index1 -  ,  ,  ,  
*!*	  field2,width2,rname2,index2
*!*	  field3,width3,rname3,index3
*!*	  field4,width4,rname4,index4
*!*	  field5,width5,rname5,index5
  *     .   ?!


 LOCAL m.para,m_nearstat,m_exactstat,m.orderstat,m.totw,m.i,;
  m_fn,m_wd,m_rn,m_oldcaps,M_OKNO,M_VOKNO,M.FFF,m.colwidth,m.resor,;
  M.FWIDTH,M.FHEIGHT,M.STEP,M_IND,M_LIST,M_OBJ,M.ALIPOISK
 PRIVATE m.numf
 m.para=PARAMETERS()
 m.numf=IIF(BETWEEN (m.para,6,9),1,;
  IIF (BETWEEN (m.para,10,13),2,;
  IIF (BETWEEN (m.para,14,17),3,;
  IIF (BETWEEN (m.para,18,21),4,;
  IIF (BETWEEN (m.para,22,25),5,0 )))))
 IF m.numf=0
  WAIT"H     POISK" WINDOW
  SUSP
  RETURN
 ENDIF
 M.ALIPOISK=ALIAS() 
 m.orderstat= SAVEORD()
 m_nearstat = SET([NEAR])
 m_exactstat= SET([EXACT])
 SET NEAR ON
 SET EXACT OFF
 PUSH KEY CLEAR
 DO CASE
  CASE m.numf=1
   STORE 0 TO width2,width3,width4,width5
  CASE m.numf=2
   STORE 0 TO width3,width4,width5
  CASE m.numf=3
   STORE 0 TO width4,width5
  CASE m.numf=4
   STORE 0 TO width5
 ENDCASE
 M_OKNO=CREATEOBJECT("oknoPOISKa")
 M_OKNO.NAME=OKNO()
 M.FWIDTH =FONTMETRIC(6,M_OKNO.FONTNAME,M_OKNO.FONTSize)
 M.FHEIGHT=FONTMETRIC(1,M_OKNO.FONTNAME,M_OKNO.FONTSize)
 *******************  
 IF EMPTY(M.R0) AND EMPTY(M.C0)
  STORE 1 TO m.r0,M.C0
  M_OKNO.AUTOCENTER  =.T.
 ENDIF 
 m.totw=MIN(width1+width2+width3+width4+width5+m.numf+2,100)
 *********************************
 M_OKNO.CAPTION  =M.TIT
 M_OKNO.TOP      =m.R0*M.FWIDTH
 M_OKNO.LEFT     =m.C0*M.FHEIGHT
 M_OKNO.WIDTH    =(M.TOTW+1)*M.FWIDTH
 M_OKNO.HEIGHT   =24*M.FHEIGHT
 M_OKNO.SAY.TOP  =M_OKNO.HEIGHT-24
 M_OKNO.SAY.WIDTH=((m.TOTW+1)*M.FWIDTH)/2-2

 M_OKNO.STRING.TOP=M_OKNO.HEIGHT-24
 M_OKNO.STRING.WIDTH=((m.TOTW+1)*M.FWIDTH)/2-2
 M_OKNO.STRING.LEFT=M_OKNO.SAY.LEFT+2+M_OKNO.SAY.WIDTH

 
 M_LIST="LIST_"+M.ALIPOISK
 M_OKNO.AddObject(M_LIST,"GRID")

 M_OKNO.&M_list..RecordSource = M.ALIPOISK
 M_OKNO.&M_list..ColumnCount = 0
 M_OKNO.&M_list..Height = M_OKNO.HEIGHT-30
 M_OKNO.&M_list..Width  = M_OKNO.WIDTH-4
 M_OKNO.&M_list..RecordSourceType = 1
 M_OKNO.&M_list..Visible = .T.
 M_OKNO.&M_list..DeleteMark = .F.
 M_OKNO.&M_list..PanelLink = .F.
 M_OKNO.&M_list..RecordMark = .F.
 M_OKNO.&M_list..ScrollBars = 2
 M_OKNO.&M_list..StatusBarText = "    ...     ; {Enter}-; {Esc}-"
 
 STORE "" TO m.colwidth,m.resor
 M.STEP=10
 
 FOR m.i=1 TO m.numf
  m_fn="FIELD"+STR(m.i,1)
  m_fn=&m_fn
  m_fn=ALLTRIM(m_fn)
  m_wd="WIDTH"+STR(m.i,1)
  m_wd=&m_wd
  m_wd=ALLTRIM(STR(m_wd*M.FWIDTH,10))
  
  m_rn="RNAME"+STR(m.i,1)
  m_rn=&m_rn
  m_rn=ALLTRIM(m_rn)
  
  m_ind="INDEX"+STR(m.i,1)
  m_ind=&m_ind
  m_ind=ALLTRIM(m_ind)
  
  M_OBJ='Column'+ALLTRIM(STR(M.I))
  
  M_OKNO.&M_list..AddObject(M_OBJ,'MyColumn') 
  M_OKNO.&M_list..&M_OBJ..ControlSource = M_FN
  M_OKNO.&M_list..&M_OBJ..Width = VAL(M_WD)
  M_OKNO.&M_list..&M_OBJ..Text1.Visible = .T.
  M_OKNO.&M_list..&M_OBJ..Visible = .T.
  M_OKNO.&M_list..&M_OBJ..ReadOnly = .T.
  M_OKNO.&M_list..&M_OBJ..Header1.Caption = M_RN
  M_OKNO.&M_list..&M_OBJ..Header1.Alignment = 6

 ENDFOR

 IF !EMPTY(M_USL)
  SET FILTER TO &M_USL
 ENDIF 
 IF !EMPTY(M_FUNC)
  M.FFF=FUNKEY(M_FUNC)
 ELSE
  M.FFF=FUNKEY(0)
 ENDIF 
 ***************** 
 SET ORDER TO TAG (index1)
 M_OKNO.STRING.VALUE =""
 M_OKNO.SAY.CAPTION =" "+Rname1+":"
 **********************************************
 
 M_OKNO.SHOW()

 IF !EMPTY(M_USL)
  SET FILTER TO 
 ENDIF 
 POP KEY
 =FUNKEY(M.FFF)
 SET NEAR &m_nearstat
 SET EXACT &m_exactstat
 SELECT (M.ALIPOISK)
 =GOMAC(m.orderstat)
 RETURN

**********************H *************************************************************

 DEFINE CLASS OknoPoiska AS form
	Top = 0
	Left = 0
	Height = 313
	Width = 577
	DoCreate = .T.
	BorderStyle = 1
	Caption = ""
	FontName = "Courier New Cyr"
	WindowType = 1
	MaxButton = .F.
	MinButton = .F.

	ADD OBJECT say AS label WITH ;
		FontName = "Courier New Cyr", ;
		Caption = "", ;
	    Alignment = 1, ;
		Height = 20, ;
		Left = 0, ;
		Top = 288,;
		Width = 253, ;
		Name = "SAY"

	ADD OBJECT string AS textbox WITH ;
		Height = 20, ;
		Left = 252, ;
		Top = 288, ;
		Width = 324, ;
		Name = "STRING"

    PROCEDURE string.When
	 RETURN .F.
	ENDPROC

 	PROCEDURE KeyPress
	 LPARAMETERS nKeyCode, nShiftAltCtrl
	 IF NkeyCode=27 
      RELEASE THISFORM
     ENDIF
	ENDPROC
    
    PROCEDURE SEARCH	
	Lparameter keypress,m.back
	PUSH KEY CLEAR
	IF EMPTY(M.BACK)
	 THISFORM.STRING.VALUE = THISFORM.STRING.VALUE+UPPER(CHR(keypress))
	ELSE
	  THISFORM.STRING.VALUE = SUBSTR(THISFORM.STRING.VALUE,1,LEN(THISFORM.STRING.VALUE)-1)
	ENDIF 
	LOCAL M.REC,M_WONTOP
	M.REC=SAVEREC()
    SEEK THISFORM.STRING.VALUE
	IF !FOUND()
	 IF EMPTY(M.BACK)
	  THISFORM.STRING.VALUE=SUBSTR(THISFORM.STRING.VALUE,1,LEN(THISFORM.STRING.VALUE)-1)
	 ENDIF 
     =GOMAC(M.REC)
	ENDIF
	POP KEY
	RETURN


ENDDEFINE

DEFINE CLASS MyColumn AS Column
 Width = 10
 ADD OBJECT Header1 AS Header
 ADD OBJECT Text1 AS TextBox
   
 PROCEDURE Text1.WHEN() 
  DO CASE
   CASE numf>=1 .AND. UPPER((field1))=UPPER(VARREAD()) .AND. ORDER()<>UPPER(index1)
    SET ORDER TO TAG (index1)
    THISFORM.STRING.VALUE =""
    THISFORM.SAY.CAPTION =" "+Rname1+":"
    THISFORM.REFRESH
   CASE numf>=2 AND UPPER((field2))=UPPER(VARREAD()) AND ORDER()<>UPPER(index2)
    SET ORDER TO TAG (index2)
    THISFORM.STRING.VALUE =""
    THISFORM.SAY.CAPTION =" "+Rname2+":"
    THISFORM.REFRESH
   CASE numf>=3 .AND. UPPER((field3))=UPPER(VARREAD()) .AND. ORDER()<>UPPER(index3)
    SET ORDER TO TAG (index3)
    THISFORM.STRING.VALUE =""
    THISFORM.SAY.CAPTION =" "+Rname3+":"
    THISFORM.REFRESH
   CASE numf>=4 .AND. UPPER((field4))=UPPER(VARREAD()) .AND. ORDER()<>UPPER(index4)
    SET ORDER TO TAG (index4)
    THISFORM.STRING.VALUE =""
    THISFORM.SAY.CAPTION =" "+Rname4+":"
    THISFORM.REFRESH
   CASE numf=5 .AND. UPPER((field5))=UPPER(VARREAD()) .AND. ORDER()<>UPPER(index5)
    SET ORDER TO TAG (index5)
    THISFORM.STRING.VALUE =""
    THISFORM.SAY.CAPTION =" "+Rname5+":"
    THISFORM.REFRESH
   OTHERWISE
  ENDCASE
 ENDPROC
 
 PROCEDURE TEXT1.KEYPRESS
 LPARAMETERS nKeyCode, nShiftAltCtrl
 DO CASE 
  CASE nKeyCode >=32 AND nKeyCode<=122  &&& 
   NODEFAULT
   THISFORM.search(nKeyCode)
  CASE nKeyCode>=192 AND nKeyCode<=255   &&& 
   NODEFAULT
   THISFORM.search(nKeyCode)
  CASE nKeyCode=127  &&& BackSPACE
   NODEFAULT
   THISFORM.search(nKeyCode,1)
  CASE nKeyCode=13  &&& Enter
   NODEFAULT
   RELEASE THISFORM
 ENDCASE
 RETURN
ENDDEFINE